<template>
  <svg>
    <g v-for="(r, i) in rects" :key="i">
      <rect
        :x="r.x" :y="r.y"
        :width="r.width"
        :height="r.height" stroke="black"
        fill="transparent"
        stroke-width="1"
      />
    </g>
  </svg>
</template>

<script lang="ts">
import type {
  Onset, Pixel, Rect, Signature, Source,
} from '@/data';
import PixelUtils from '@/data/PixelUtils';
import { Component, Prop, Vue } from 'vue-property-decorator';

@Component
export default class CanvasSourceGrid extends Vue {
  @Prop({ required: true })
  source!: Source;

  @Prop({ required: true })
  signature!: Signature;

  rects: Array<Rect> = [];

  mounted() {
    const increment = 4;
    const { pixelUnit } = this.source;
    if (this.source.pages) {
      let currentOnset = 0;
      for (let j = 0; j < this.source.pages?.length; j += 1) {
        const rows = this.source.pages?.at(j)?.rows;
        if (rows && rows.length) {
          for (
            let i = currentOnset;
            i <= ((rows.length + 1) * (4 * increment));
            i += increment, currentOnset += increment
          ) {
            const startPixel = PixelUtils.deMux(pixelUnit.fromOnset(i + 0.01 as Onset).value);
            const endPixel = PixelUtils.deMux(pixelUnit.fromOnset(i + increment as Onset).value);
            const width = endPixel.x - startPixel.x as Pixel;

            let x: Pixel = 0 as Pixel;
            if (endPixel.row !== startPixel.row || endPixel.page !== startPixel.page) {
              x = endPixel.x - width as Pixel;
            } else {
              x = startPixel.x;
            }

            // Pas générique, ne prend pas la hauteur de chaque page
            const y = (startPixel.row * rows[0].height)
              + (startPixel.page * this.source.pages[j].height) as Pixel;

            const rect = {
              x,
              y,
              width,
              height: rows[0].height as Pixel,
            };
            this.rects.push(rect);
          }
        }
      }
    }
  }
}
</script>
